## reposurgeon 4.31

=== Makefile ===
#
# makefile for reposurgeon
#
INSTALL=install
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

META = README.adoc INSTALL.adoc NEWS.adoc
PAGES = reposurgeon.adoc repocutter.adoc repomapper.adoc repotool.adoc repobench.adoc
DOCS = $(PAGES) repository-editing.adoc oops.svg
SOURCES = $(shell ls */*.go) repobench reposurgeon-mode.el go.mod go.sum extractversion.sh
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
SOURCES += Dockerfile ci/prepare.sh .gitlab-ci.yml
SOURCES += $(META) $(DOCS) COPYING

.PHONY: all build install uninstall version check release refresh \
	docker-build docker-check docker-check-noscm get test fmt lint

# Conditionalize building of documentation on wherther our formatter is installed
ifneq (, $(shell which asciidoctor))
HTMLFILES = $(DOCS:.adoc=.html) $(META:.adoc=.html)
endif

BINARIES  = reposurgeon repotool repomapper repocutter
INSTALLABLES = $(BINARIES) repobench
MANPAGES  = $(PAGES:.adoc=.1)
SHARED    = $(META) reposurgeon-git-aliases $(HTMLFILES) COPYING

.PHONY: all fullinstall build stable-golang current-golang helpers test-helpers \
		get test lint fmt clean install uninstall dist release refresh

awk_supports_posix_arg = $(shell awk --posix "" >/dev/null 2>&1; echo $$?)
ifeq ($(awk_supports_posix_arg), 0)
AWK = awk --posix
else
AWK = awk
endif

# Binaries need to be built before generated documentation parts can be made.
all: build cuttercommands.inc $(MANPAGES) $(HTMLFILES)

# The following would produce reproducible builds, but it breaks Gitlab CI.
#GOFLAGS=-gcflags 'all=-N -l -trimpath $(GOPATH)/src' -asmflags 'all=-trimpath $(GOPATH)/src'
build: surgeon/help-index.go
	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go
	go build $(GOFLAGS) -o repocutter ./cutter
	go build $(GOFLAGS) -o repomapper ./mapper
	go build $(GOFLAGS) -o reposurgeon ./surgeon
	go build $(GOFLAGS) -o repotool ./tool

reposurgeon: build

#
# Fast installation in apt-world. Fire either stable-golang or current-golang,
# then helpers, then test-helpers if you want to run the test suite,
#
fullinstall: stable-golang helpers test-helpers

stable-golang:
	sudo apt-get -y install golang

# This may improve performance, if the backports repostotory
# has been updated to a version more recemnt than your distro's.
current-golang:
	sudo add-apt-repository ppa:longsleep/golang-backports
	sudo apt update
	sudo apt install golang-go
	go version

# As of Ubuntu 20.04 there is no longer a package names "awk".
helpers:
	command -v asciidoctor >/dev/null 2>&1 || sudo apt-get -y install asciidoctor
	command -v awk >/dev/null 2>&1 || sudo apt-get -y install gawk


test-helpers:
	sudo apt-get -y install cvs-fast-export subversion cvs mercurial rsync golint shellcheck

#
# Documentation
#

# Note: to suppress the footers with timestamps being generated in HTML,
# we use "-a nofooter".
# To debug asciidoc problems, you may need to run "xmllint --nonet --noout --valid"
# on the intermediate XML that throws an error.
.SUFFIXES: .html .adoc .1

.adoc.1:
	asciidoctor -D. -a nofooter -b manpage $<
.adoc.html:
	asciidoctor -D. -a webfonts! $<

# This is a list of help topics for which the help is in regular format
# and there is no additional material included in the long-form mnual only.
# This means there's one line of BNF, a blank separator line, and one or
# more blank-line-separated paragraphs of running text.
BNF_TOPICS = \
	add \
	append \
	authors \
	assign \
	blob \
	branch \
	branchlift \
	changelogs \
	checkout \
	choose \
	clear \
	coalesce \
	count \
	debranch \
	dedup \
	define \
	delete \
	diff \
	divide \
	do \
	drop \
	elapsed \
	exit \
	expunge \
	filter \
	gc \
	gitify \
	graft \
	graph \
	hash \
	help \
	history \
	ignores \
	incorporate \
	index \
	inspect \
	legacy \
	lint \
	list \
	log \
	logfile \
	manifest \
	memory \
	merge \
	msgin \
	msgout \
	names \
	path \
	prefer \
	prepend \
	preserve \
	print \
	quit \
	readlimit \
	rebuild \
	references \
	remove \
	rename \
	renumber \
	reorder \
	reset \
	resolve \
	script \
	set \
	setfield \
	setperm \
	shell \
	sizeof \
	sizes \
	sourcetype \
	split \
	stamp \
	stats \
	strip \
	tag \
	tagify \
	tags \
	timeoffset \
	timequake \
	timing \
	transcode \
	unassign \
	undefine \
	unite \
	unmerge \
	unpreserve \
	version \
	when
UNANCHORED_TOPICS = \
	functions \
	options \
	redirection \
	regexp \
	selection \
	syntax
READ_OPTION_TOPICS = \
	branchify
TOPICS = $(BNF_TOPICS) $(UNANCHORED_TOPICS) $(READ_OPTION_TOPICS)
# These are in regular form, but the entries in the
# long-form manual have additional material.
SHORTFORM = \
	read \
	squash \
	write
# These are all the non-regular topics
EXCEPTIONS = \
	attribution \
	lint \
	profile \
	reparent
# Most of the command descriptions in Repositpory editing are reposurgeon's embedded
# help, lightly massaged into asciidoc format.
repository-editing.html: surgeon/reposurgeon.go reposurgeon repository-editing.adoc
	@rm -fr docinclude; mkdir docinclude
	@get_help() { \
		./reposurgeon "set asciidoc" "help $${1}" | awk -f poundsign.awk; \
	}; \
	for topic in $(BNF_TOPICS); \
	do \
		echo "[[$${topic}_cmd,$${topic}]]" >>"docinclude/$${topic}.adoc"; \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done; \
	for topic in $(UNANCHORED_TOPICS); \
	do \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done; \
	for topic in $(READ_OPTION_TOPICS); \
	do \
		echo "[[$${topic}_opt,--$${topic}]]" >>"docinclude/$${topic}.adoc"; \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done
	@./reposurgeon "help options" | sed '/:/s//::/' >docinclude/options.adoc
	@./repository-editing.rb

# Audit for embedded-help entries not used as inclusions (column 1)
# or inclusions for which there are no corresponding help topics (column 2).
# Column 2 should always be empty.
helpcheck:
	@(for topic in $(TOPICS); do echo $${topic}; done) | sort >/tmp/topics$$$$; \
	sed -n <repository-editing.adoc '/include::docinclude\/\([a-z]*\).adoc\[\]/s//\1/p' | sort >/tmp/includes$$$$ ; \
	comm -3 /tmp/topics$$$$ /tmp/includes$$$$; \
	rm /tmp/topics$$$$ /tmp/includes$$$$

# Report most grammar summary lines. Missing: the SHORTFORM and EXCEPTION topics.
summary:
	@for topic in $(BNF_TOPICS); do head -2 "docinclude/$${topic}.adoc"; done | grep -v '^\[\[' | sed '/::$$/s///'

surgeon/help-index.go: help-index.awk repository-editing.adoc
	$(AWK) -f $^ >$@

cuttercommands.inc: repocutter
	./repocutter --docgen >cuttercommands.inc

#
# Auxiliary Go tooling productions
#

get:
	go get -u ./...	# go get -u=patch for patch releases

test:
	go test $(TESTOPTS) ./surgeon
	go test $(TESTOPTS) ./cutter

lint:
	golint -set_exit_status ./...
	shellcheck -f gcc extractversion.sh repobench test/fi-to-fi test/liftcheck test/singlelift test/svn-to-git test/svn-to-svn test/delver test/*.sh test/*test

fmt:
	gofmt -w .

#
# Cleaning
#
clean:
	rm -f $(BINARIES) surgeon/version.go
	rm -fr docinclude cuttercommands.inc *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript

#
# Installation
#
# Note that this does not run a build, so it will error out (harmlessly) if you 
# have not done "make all" or "make build" first.  There's a conflict between
# Go's preference for Rebuilding All The Things and the traditional makefile
# attempt to do as little build work as possible at any given time.
#
install:
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 $(INSTALLABLES) "$(target)/bin"
	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"

#
# Uninstallation
#

INSTALLED_BINARIES := $(INSTALLABLES:%="$(target)/bin/%")
INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")

uninstall:
	rm -f $(INSTALLED_BINARIES)
	rm -f $(INSTALLED_MANPAGES)
	rm -f $(INSTALLED_SHARED)
	rmdir "$(target)/share/doc/reposurgeon"

VERS=$(shell sh ./extractversion.sh <NEWS.adoc)

version:
	@echo $(VERS)

#
# Code validation
#

check: lint all test
	$(MAKE) -C test --quiet check BINDIR=$(realpath $(CURDIR))

fixme:
	@if command -v rg; then \
		rg --no-heading FIX''ME; \
	else \
		find . -type f -exec grep -n FIX''ME {} /dev/null \; | grep -v "[.]git"; \
	fi

#
# Continuous integration.  More specifics are in the ci/ directory
#

docker-build: $(SOURCES)
	docker build -t reposurgeon .

docker-check: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon make check

docker-check-only-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-only-$(*) && make check"

docker-check-no-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-no-$(*) && make check"

# Test that support for each VCS stands on its own and test without legacy
# VCS installed
docker-check-noscm: docker-check-only-bzr docker-check-only-cvs \
    docker-check-only-git docker-check-only-mercurial \
    docker-check-only-subversion docker-check-no-cvs 
# Due to many tests depending on git, docker-check-only-mercurial is a very poor
# test of Mercurial

#
# Release shipping.
#

# Don't try using tar --transform, it tries to get too clever with symlinks 
reposurgeon-$(VERS).tar.xz: $(SHIPPABLE)
	(git ls-files; ls *.1) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
	(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
	(cd ..; rm reposurgeon-$(VERS) reposurgeon/MANIFEST)

dist: reposurgeon-$(VERS).tar.xz

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 $(HTMLFILES)
	shipper version=$(VERS) | sh -e -x

refresh: $(HTMLFILES)
	shipper -N -w version=$(VERS) | sh -e -x

# end

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# Different implementations could be plugged in to the tests.
REPOSURGEON := reposurgeon 
REPOCUTTER := repocutter 
REPOTOOL := repotool
REPOMAPPER := repomapper

# Setting this to 1 suppresses detail sections in most TAP reportts.
QUIET=0

# The TAP filter. Only affects presentation of the test suite messages
TAPCONSUMER=tapview

# No user-serviceable parts below this line.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(BINDIR):$(realpath ..):$(realpath .):${PATH}

# Force the timezone in case CI has a different idea.
# Havoc ensues if this is not exported - not clear why.
export TZ=UTC

# Force pure serial execution when rebuilding check files.  Slower,
# but makes them deterministic and may help smoke out bugs in
# concurrent code.
BUILDOPT="set serial"

# See https://stackoverflow.com/questions/6481005/how-to-obtain-the-number-of-cpus-cores-in-linux-from-the-command-line
CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)

# Fall back to safety if our declared TAP consumer does not exist.
# This is helpful in the CI environment, where it wiuld be better for
# the logfiles to carry the raw TAP messages. 
TAPFILTER=$(shell command -v $(TAPCONSUMER) || echo cat)

# Run specified tests in parallel and ship their output to our TAP consumer after a plan header
TAPOUT = (echo "1..$(words $(1))"; $(MAKE) --output-sync --no-print-directory -j $(CONCURRENT_JOBS) $(1)) | $(TAPFILTER)

# Test whether we have a specified command
AVAILABLE=command -v $(1) >/dev/null 2>&1

# Parallel make doesn't return a fail status when a single subprocess fails,
# so we need to log the failures and check the log for nonemptiness in order
# to hand a real status back. This is important for CI/CD.  
FAILLOG=/tmp/reposurgeon-make.log

# parallel-tap must not be run in parallel.
check:
	@$(MAKE) -j1 --no-print-directory parallel-tap

.SUFFIXES: .svn .chk .fi .map .sh .see

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "log -all" "read <$<" "legacy write -" >$@
.sh.svn:
	sh $< -d >$@
.svn.see:
	@repocutter -q see <$< >$@

clean:
	@rm -fr .rs* test=repo test-checkout test-repo* test-checkout* git-repo left-repo right-repo *~

options:
	@echo "REPOSURGEON is '$(REPOSURGEON)'"
	@echo "TESTOPT is '$(TESTOPT)'"

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst *.sh
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description" >&2; exit 1; fi;  \
	done

# BEGINS: Tests that require only reposurgeon itself

# Test that all stream files round-trip properly: compressed, uncompressed,
# and when passed through as message boxes by msgin/msgout.
ROUNDTRIP_TARGETS=$(patsubst %,roundtrip-%,$(wildcard *.fi))
ROUNDTRIP_COMPRESS_TARGETS=$(patsubst %,roundtrip-compress-%,$(wildcard *.fi))
MESSAGEBOX_TARGETS=$(patsubst %,messagebox-%,$(wildcard *.fi))

# Stream roundtripping tests
$(ROUNDTRIP_TARGETS): roundtrip-%: %
	@($(REPOSURGEON) "$(TESTOPT)" "read -; write -" <$< | tapdiffer "$< roundtrip" $<) || echo "$@" >>$(FAILLOG);
$(ROUNDTRIP_COMPRESS_TARGETS): roundtrip-compress-%: %
	@($(REPOSURGEON) "$(TESTOPT)" "set compress" "read -; write -" <$< | tapdiffer "$< compressed roundtrip" $<) || echo "$@" >>$(FAILLOG);
$(MESSAGEBOX_TARGETS): messagebox-%: %
	@($(REPOSURGEON) "$(TESTOPT)" "read <$<" "msgout >/tmp/msgbox$$$$" "msgin </tmp/msgbox$$$$" "write -" "shell rm /tmp/msgbox$$$$" | tapdiffer "$< message-box roundtripping" $<) || echo "$@" >>$(FAILLOG);

# Generated command-test loads
GENERATEDSVN=multigen.svn ignore.svn global-ignores.svn ignore-copy.svn global-ignores-copy.svn tagdoublet.svn \
	mixedbranchlift.svn tagwithcommits.svn branchtagdoublet.svn multiprojectmerge.svn branchrenametipdelete.svn \
	branchcreateempty.svn
ignore.svn: ignoregen.sh
	sh $< ignore >$@
global-ignores.svn: ignoregen.sh
	sh $< global-ignores >$@
ignore-copy.svn: ignoregen.sh
	sh $< ignore copy >$@
global-ignores-copy.svn: ignoregen.sh
	sh $< global-ignores copy >$@

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
COMMAND_LOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
COMMAND_TARGETS=$(COMMAND_LOADS:%=command-regress-%)
$(COMMAND_TARGETS): command-regress-%: %.tst
	@singletest -a testing123 $< || echo "$@" >>$(FAILLOG);
command-buildregress: $(GENERATEDSVN)
	@for file in $(COMMAND_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) $(BUILDOPT) "$(TESTOPT)" "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit 1; \
	done

# Regression-yest loading from Subversion
SVN_AND_TST_FILES := $(sort $(wildcard *.svn *.tst))
SVNLOAD_LOADS := $(shell echo $(SVN_AND_TST_FILES) | sed 's/\([^ ]*\)\.svn \1.tst//g; s/[^ ]*\.tst//g; s/\.svn//g')
svnload-buildregress:
	@for test in $(SVNLOAD_LOADS); do \
	    if [ -f $${test}.tst ] ; \
	    then \
		    echo "BUG: $${test} should have been skipped: $${test}.tst exists"; \
		    exit 1; \
		fi; \
		echo "Remaking $${test}.chk"; \
		rm -f $${test}.chk && $(MAKE) --quiet $${test}.chk || exit 1; \
	done
SVNLOAD_TARGETS=$(SVNLOAD_LOADS:%=svnload-regress-%)
$(SVNLOAD_TARGETS): svnload-regress-%: %.svn
	@(test=$(<:.svn=); legend=$$(sed -n '/^ ## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
	$(REPOSURGEON) "$(TESTOPT)" "$(TESTOPT)" "read <$${test}.svn" "prefer git" "write -"  >/tmp/stream$$$$ 2>&1; \
	tapdiffer "$<: $${legend}" $${test}.chk </tmp/stream$$$$ ) || echo "$@" >>$(FAILLOG);

# Regression-testing of repocutter
REPOCUTTER_LOADS := $(shell ls -1 repocutter*.sh | sed '/.sh$$/s///')
repocutter-buildregress:
	@for file in $(REPOCUTTER_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
	done
REPOCUTTER_TARGETS = $(REPOCUTTER_LOADS:%=repocutter-test-%)
$(REPOCUTTER_TARGETS): repocutter-test-%:
	@(legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh | tapdiffer "$${legend}" $*.chk) || echo "$@" >>$(FAILLOG);

# Regression-testing of repomapper; look at the *.sh and
# corresponding *.chk files to see which tests this runs.
REPOMAPPER_LOADS := $(shell ls -1 repomapper*.sh | sed '/.sh/s///')
repomapper-buildregress:
	@for file in $(REPOMAPPER_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
	done
REPOMAPPER_TARGETS = $(REPOMAPPER_LOADS:%=mapper-test-%)
$(REPOMAPPER_TARGETS): mapper-test-%:
	@(legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh | tapdiffer "$${legend}" $*.chk) || echo "$@" >>$(FAILLOG);

# Test legacy-map generation
LEGACY_LOADS=nut mergeinfo-with-split
legacy-buildregress:
	@for test in $(LEGACY_LOADS); \
	do \
	    echo "Remaking $${test}.map"; \
	    rm -f $${test}.map && $(MAKE) --quiet $${test}.map 2>/dev/null || exit 1; \
	done
LEGACY_TARGETS = $(LEGACY_LOADS:%=legacy-test-%)
$(LEGACY_TARGETS): legacy-test-%: %.svn
	@(legend=$$(sed -n '/^ ## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
	$(REPOSURGEON) "$(TESTOPT)" "read <$<" "legacy write -" | grep -v '^reposurgeon:' 2>/dev/null \
	| tapdiffer "$${legend}" $(basename $<).map) || echo "$@" >>$(FAILLOG);

# ENDS: Tests that require only reposurgeon itself

# BEGINS: Tests requiring svn but not git

ifneq ($(call AVAILABLE svn),)

# Regression-testing of Subversion permission-bit and other exceptional cases.
# These tests are actually here to check Subversion's behavior, in case something
# poorly documented changes.
SVNCHECK_LOADS := $(shell ls -1 svncheck*.sh | sed '/.sh/s///')
svncheck-buildregress:
	@for file in $(SVNCHECK_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh -d | $(REPOSURGEON) "$(TESTOPT)" "set testmode" 'read -' 'prefer git' 'write -' >$${file}.chk || exit 1; \
	done
SVNCHECK_TARGETS = $(SVNCHECK_LOADS:%=svncheck-test-%)
$(SVNCHECK_TARGETS): svncheck-test-%:
	@(legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh -d | $(REPOSURGEON) "$(TESTOPT)" "set testmode" 'read -' 'prefer git' 'write -' \
	| tapdiffer "$*: $${legend}" $*.chk) || echo "$@" >>$(FAILLOG);

endif # if svn

# ENDS: Tests requiring svn but not git

# All tests past this point reqire Git

ifneq ($(call AVAILABLE git),)

# BEGINS: Tests requiring svn and git

ifneq ($(call AVAILABLE svn),)

# Test Subversion conversion correctness
LIFTCHECK_LOADS = $(wildcard *.svn)
LIFTCHECK_TARGETS = $(LIFTCHECK_LOADS:%=liftcheck-regress-full-%)
$(LIFTCHECK_TARGETS): liftcheck-regress-full-%: %
	@liftcheck -q -r all $< || echo "$@" >>$(FAILLOG);

endif # if svn

# ENDS: Tests requiring svn and git

# BEGINS: Tests requiring git only

# Test the git extractor
GIT_EXTRACTOR_LOADS= bs.fi testrepo2.fi utf8.fi
GIT_EXTRACTOR_TARGETS = $(GIT_EXTRACTOR_LOADS:%=git-extractor-test-%)
$(GIT_EXTRACTOR_TARGETS): git-extractor-test-%: %
	@(./fi-to-fi <$< | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: git extractor round-tripping" $<) || echo "$@" >>$(FAILLOG);

# ENDS: Tests requiring git only

# BEGINS: Tests requiring hg

ifneq ($(call AVAILABLE hg),)

# Test the hg support
HGSTREAMS = testrepo2
HGSTREAMS_EXTRACTOR_TARGETS = $(HGSTREAMS:%=hg-extractor-test-%)
$(HGSTREAMS_EXTRACTOR_TARGETS): hg-extractor-test-%: %.fi
	@(./hg-to-fi <$< | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: hg extractor" $<) || echo "$@" >>$(FAILLOG);
HGSCRIPTS = $(subst -test,,$(subst hg-,,$(wildcard hg-*-test)))
hg-buildregress:
	@for item in $(HGSCRIPTS); do \
	    echo "Remaking $${item}.fi"; \
	    ./hg-$${item}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${item}.fi \
		2>&1 || exit 1; \
	done
HG_EXTRACTOR_TARGETS=$(HGSCRIPTS:%=hg-extractor-test-%)
$(HG_EXTRACTOR_TARGETS): hg-extractor-test-%: %.fi
	@(./hg-$*-test | sed -e 1d -e '/^#legacy-id/d'  | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: hg extractor round-tripping" $<) || echo "$@" >>$(FAILLOG)

endif # if hg

# ENDS: Tests requiring hg

endif # if git

# Test past this point may depend on any VCS and are expected
# to die cleanly wuth a TAP complaint if they can't find what they need.

# Regression-testing of repotool; look at the *.sh and
# corresponding *.chk files to see which tests this runs.
REPOTOOL_LOADS := $(shell ls -1 repotool*.sh | sed '/.sh/s///')
repotool-buildregress:
	@for file in $(REPOTOOL_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh --rebuild || exit 1; \
	done
REPOTOOL_TARGETS = $(REPOTOOL_LOADS:%=repotool-test-%)
$(REPOTOOL_TARGETS): repotool-test-%:
	@(legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh --regress) || echo "$@" >>$(FAILLOG);

# Miscellaneous tests.
SPORADIC_LOADS := hashcheck workflow-cvs-git workflow-svn-git incrementalcheck
SPORADIC_TARGETS = $(SPORADIC_LOADS:%=sporadic-test-%)
$(SPORADIC_TARGETS): sporadic-test-%:
	@$(SHELL) $*.sh || echo "$@" >>$(FAILLOG);

# All test targets. Putting expensive targets early in this list might
# shave a little off total time. The Subversion tools are much the slowest
# so those tests start first.
TEST_TARGETS = $(LIFTCHECK_TARGETS) $(SVNCHECK_TARGETS) \
		$(GIT_EXTRACTOR_TARGETS) $(HGSTREAMS_EXTRACTOR_TARGETS) $(HG_EXTRACTOR_TARGETS) \
		$(ROUNDTRIP_TARGETS) $(ROUNDTRIP_COMPRESS_TARGETS) $(MESSAGEBOX_TARGETS) \
		$(COMMAND_TARGETS) $(SVNLOAD_TARGETS) $(LEGACY_TARGETS) \
		$(REPOMAPPER_TARGETS) $(REPOTOOL_TARGETS) $(REPOCUTTER_TARGETS) \
		$(SPORADIC_TARGETS)

# Here's how we actually run the tests:

# Issue a straight TAP report, no parallelism or filtering

=== debian/changelog ===
reposurgeon (4.31-1) unstable; urgency=medium

  * New upstream version 4.31
  * Reorder fields in debian/control and debian/copyright
    as would be generated in the next dh-make-golang release after 0.6.0-1
  * Use dh-sequence-golang instead of dh-golang and --with=golang
  * Add build-dependency golang-github-pkg-term-dev (>= 1.1.0)

 -- Anthony Fok <foka@debian.org>  Tue, 11 Jan 2022 18:53:25 -0700

reposurgeon (4.30-1) unstable; urgency=medium

  * New upstream version 4.30
  * Refresh 0001-Makefile-skip-build.patch
  * Bump Standards-Version to 4.6.0 (no change)
  * Update local copy of yet-to-be-packaged dependent Go library
    - gitlab.com/ianbruene/kommandant v0.6.2
  * Remove local copy of github.com/ianbruene/go-difflib v1.2.0
    and add dependency on golang-github-ianbruene-go-difflib-dev instead

 -- Anthony Fok <foka@debian.org>  Fri, 03 Dec 2021 04:13:26 -0700

=== debian/control ===
Source: reposurgeon
Section: vcs
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Anthony Fok <foka@debian.org>
Rules-Requires-Root: no
Build-Depends: asciidoctor,
               cvs,
               debhelper-compat (= 13),
               dh-sequence-golang,
               git,
               golang-any,
               golang-github-anmitsu-go-shlex-dev (>= 0.0~git20200514.38f4b40),
               golang-github-chzyer-readline-dev (>= 1.4.39.g2972be2),
               golang-github-emirpasic-gods-dev (>= 1.12.0),
               golang-github-ianbruene-go-difflib-dev (>= 1.2.0),
               golang-github-kballard-go-shellquote-dev (>= 0.0~git20180428.95032a8),
               golang-github-pkg-term-dev (>= 1.1.0),
               golang-github-xo-terminfo-dev (>= 0.0~git20210125.ca9a967),
               golang-golang-x-crypto-dev,
               golang-golang-x-text-dev,
               mercurial,
               subversion,
               time
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/reposurgeon
Vcs-Git: https://salsa.debian.org/go-team/packages/reposurgeon.git
Homepage: http://www.catb.org/esr/reposurgeon/
XS-Go-Import-Path: gitlab.com/esr/reposurgeon

Package: reposurgeon
Architecture: any
Depends: tzdata,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cvs,
            cvs-fast-export,
            git,
            subversion
Suggests: brz,
          darcs,
          fossil,
          hg-fast-export
Built-Using: ${misc:Built-Using}
Description: Tool for editing version-control repository history
 `reposurgeon` enables risky operations that version-control systems
 don't want to let you do, such as (a) editing past comments and metadata,
 (b) excising commits, (c) coalescing commits, and (d) removing files and
 subtrees from repo history. The original motivation for `reposurgeon`
 was to clean up artifacts created by repository conversions.
 .
 `reposurgeon` is also useful for scripting very high-quality
 conversions from Subversion.  It is better than `git-svn` at tag
 lifting, automatically cleaning up `cvs2svn` conversion artifacts,
 dealing with nonstandard repository layouts, recognizing branch
 merges, handling mixed-branch commits, and generally at coping with
 Subversion's many odd corner cases.  Normally Subversion repos should
 be analyzed at a rate of upwards of ten thousand commits per minute,
 though that rate can fall significantly on extremely large
 repositories.
 .
 An auxiliary program, `repotool`, performs various useful
 operations such as checkouts and tag listing in a VCS-independent
 manner.  Yet another, `repomapper`, assists in automatically preparing
 contributor maps of CVS and SVN repositories.
 .
 The `repocutter` program is available for some specialized operations on
 Subversion dumpfiles; it may be useful in extracting portions of
 particularly gnarly Subversion repositories for conversion with
 reposurgeon.
 .
 This distribution supports a generic conversion workflow using these
 tools, and includes a long-form manual "Repository Editing and
 Conversion With Reposurgeon" that describes how to use it.
 .
 The file `reposurgeon-git-aliases` can be appended to your `~/.gitconfig` to
 support working directly with action stamps in git.
 .
 Finally, an Emacs Lisp mode with useful functions for editing large
 comment message-boxes is included.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := test

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_configure:
	$(MAKE) surgeon/help-index.go
	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go

execute_after_dh_auto_configure:
	ln -s $(CURDIR)/debian/go/_src _build/src/gitlab.com/esr/reposurgeon/vendor

execute_after_dh_auto_build:
	for i in cutter mapper surgeon tool; do \
		cp -al _build/bin/$$i repo$$i ; \
		done
	$(MAKE)

override_dh_auto_install:
	DH_INTERNAL_OPTIONS= dh_auto_install -- prefix=/usr
	rm -f debian/reposurgeon/usr/share/doc/reposurgeon/INSTALL.adoc

execute_after_dh_auto_test:
	$(MAKE) -k -C test --quiet check BINDIR=$(realpath $(CURDIR))

execute_after_dh_auto_clean:
	DH_INTERNAL_OPTIONS= dh_auto_clean
	-git restore '*.1'

## reposurgeon 4.35

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,8 @@
 .PHONY: all build install uninstall version check release refresh \
 	docker-build docker-check docker-check-noscm get test fmt lint
 
-# Conditionalize building of documentation on wherther our formatter is installed
+# Conditionalize building of documentation on whether our formatter is installed
+# Building the documentation also requires awk and ruby.
 ifneq (, $(shell which asciidoctor))
 HTMLFILES = $(DOCS:.adoc=.html) $(META:.adoc=.html)
 endif
@@ -28,7 +29,9 @@
 SHARED    = $(META) reposurgeon-git-aliases $(HTMLFILES) COPYING
 
 .PHONY: all fullinstall build stable-golang current-golang helpers test-helpers \
-		get test lint fmt clean install uninstall dist release refresh
+		docincludes get test lint fmt clean install uninstall dist version \
+		check fixme dist docker-build docker-check docker-check-scm release \
+		refresh
 
 awk_supports_posix_arg = $(shell awk --posix "" >/dev/null 2>&1; echo $$?)
 ifeq ($(awk_supports_posix_arg), 0)
@@ -38,11 +41,12 @@
 endif
 
 # Binaries need to be built before generated documentation parts can be made.
-all: build cuttercommands.inc $(MANPAGES) $(HTMLFILES)
+all: build cuttercommands.inc toolcommands.inc $(MANPAGES) $(HTMLFILES)
 
 # The following would produce reproducible builds, but it breaks Gitlab CI.
 #GOFLAGS=-gcflags 'all=-N -l -trimpath $(GOPATH)/src' -asmflags 'all=-trimpath $(GOPATH)/src'
 build: surgeon/help-index.go
+	-test -f go.mod || (go mod init && go get)
 	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go
 	go build $(GOFLAGS) -o repocutter ./cutter
 	go build $(GOFLAGS) -o repomapper ./mapper
@@ -72,7 +76,6 @@
 helpers:
 	command -v asciidoctor >/dev/null 2>&1 || sudo apt-get -y install asciidoctor
 	command -v awk >/dev/null 2>&1 || sudo apt-get -y install gawk
-
 
 test-helpers:
 	sudo apt-get -y install cvs-fast-export subversion cvs mercurial rsync golint shellcheck
@@ -207,9 +210,9 @@
 	lint \
 	profile \
 	reparent
-# Most of the command descriptions in Repositpory editing are reposurgeon's embedded
-# help, lightly massaged into asciidoc format.
-repository-editing.html: surgeon/reposurgeon.go reposurgeon repository-editing.adoc
+# Most of the command descriptions in Repository editing are reposurgeon's embedded
+# help, lightly massaged into asciidoc format. This is how to generate them.
+docincludes: surgeon/reposurgeon.go reposurgeon repository-editing.adoc
 	@rm -fr docinclude; mkdir docinclude
 	@get_help() { \
 		./reposurgeon "set asciidoc" "help $${1}" | awk -f poundsign.awk; \
@@ -229,7 +232,11 @@
 		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
 	done
 	@./reposurgeon "help options" | sed '/:/s//::/' >docinclude/options.adoc
+
+repository-editing.html: docincludes
 	@./repository-editing.rb
+repository-editing.pdf: docincludes
+	@asciidoctor-pdf repository-editing.adoc
 
 # Audit for embedded-help entries not used as inclusions (column 1)
 # or inclusions for which there are no corresponding help topics (column 2).
@@ -247,8 +254,11 @@
 surgeon/help-index.go: help-index.awk repository-editing.adoc
 	$(AWK) -f $^ >$@
 
-cuttercommands.inc: repocutter
-	./repocutter --docgen >cuttercommands.inc
+cuttercommands.inc: build
+	./repocutter -q docgen >cuttercommands.inc
+
+toolcommands.inc: build
+	./repotool docgen >toolcommands.inc
 
 #
 # Auxiliary Go tooling productions
@@ -273,7 +283,7 @@
 #
 clean:
 	rm -f $(BINARIES) surgeon/version.go
-	rm -fr docinclude cuttercommands.inc *~ *.1 *.html *.tar.xz MANIFEST *.md5
+	rm -fr docinclude cuttercommands.inc toolcommands.inc *~ *.1 *.html *.tar.xz MANIFEST *.md5
 	rm -fr .rs .rs* test/.rs test/.rs*
 	rm -f typescript test/typescript
 
@@ -315,6 +325,8 @@
 #
 # Code validation
 #
+# See also:
+# https://goreportcard.com/report/gitlab.com/esr/reposurgeon#L156
 
 check: lint all test
 	$(MAKE) -C test --quiet check BINDIR=$(realpath $(CURDIR))

=== test/Makefile ===
--- 
+++ 
@@ -279,7 +279,7 @@
 	$(SHELL) $*.sh --regress) || echo "$@" >>$(FAILLOG);
 
 # Miscellaneous tests.
-SPORADIC_LOADS := hashcheck workflow-cvs-git workflow-svn-git incrementalcheck
+SPORADIC_LOADS := hashcheck workflow-cvs-git workflow-svn-git incrementalcheck svndircopyprop
 SPORADIC_TARGETS = $(SPORADIC_LOADS:%=sporadic-test-%)
 $(SPORADIC_TARGETS): sporadic-test-%:
 	@$(SHELL) $*.sh || echo "$@" >>$(FAILLOG);
@@ -296,4 +296,3 @@
 
 # Here's how we actually run the tests:
 
-# Issue a straight TAP report, no parallelism or filtering

=== debian/changelog ===
reposurgeon (4.35-1) unstable; urgency=medium

  * New upstream version 4.35
  * Update versioned dependencies as per go.mod
  * Bump Standards-Version to 4.6.2 (no change)
  * Refresh debian/patches/0001-Makefile-skip-build.patch
  * Fix Lintian warning package-contains-upstream-installation-documentation
    [usr/share/doc/reposurgeon/INSTALL.html]

 -- Anthony Fok <foka@debian.org>  Wed, 29 Mar 2023 20:11:14 -0600

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,7 @@
 override_dh_auto_install:
 	DH_INTERNAL_OPTIONS= dh_auto_install -- prefix=/usr
 	rm -f debian/reposurgeon/usr/share/doc/reposurgeon/INSTALL.adoc
+	rm -f debian/reposurgeon/usr/share/doc/reposurgeon/INSTALL.html
 
 execute_after_dh_auto_test:
 	$(MAKE) -k -C test --quiet check BINDIR=$(realpath $(CURDIR))

## reposurgeon 4.38

=== Makefile ===
--- 
+++ 
@@ -45,9 +45,9 @@
 
 # The following would produce reproducible builds, but it breaks Gitlab CI.
 #GOFLAGS=-gcflags 'all=-N -l -trimpath $(GOPATH)/src' -asmflags 'all=-trimpath $(GOPATH)/src'
+GOFLAGS=-ldflags='-X main.version=$(VERS)'
 build: surgeon/help-index.go
 	-test -f go.mod || (go mod init && go get)
-	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go
 	go build $(GOFLAGS) -o repocutter ./cutter
 	go build $(GOFLAGS) -o repomapper ./mapper
 	go build $(GOFLAGS) -o reposurgeon ./surgeon
@@ -96,7 +96,7 @@
 	asciidoctor -D. -a webfonts! $<
 
 # This is a list of help topics for which the help is in regular format
-# and there is no additional material included in the long-form mnual only.
+# and there is no additional material included in the long-form manual only.
 # This means there's one line of BNF, a blank separator line, and one or
 # more blank-line-separated paragraphs of running text.
 BNF_TOPICS = \
@@ -273,7 +273,7 @@
 
 lint:
 	golint -set_exit_status ./...
-	shellcheck -f gcc extractversion.sh repobench test/fi-to-fi test/liftcheck test/singlelift test/svn-to-git test/svn-to-svn test/delver test/*.sh test/*test
+	shellcheck -f gcc repobench test/fi-to-fi test/liftcheck test/singlelift test/svn-to-git test/svn-to-svn test/delver test/*.sh test/*test
 
 fmt:
 	gofmt -w .
@@ -282,7 +282,7 @@
 # Cleaning
 #
 clean:
-	rm -f $(BINARIES) surgeon/version.go
+	rm -f $(BINARIES)
 	rm -fr docinclude cuttercommands.inc toolcommands.inc *~ *.1 *.html *.tar.xz MANIFEST *.md5
 	rm -fr .rs .rs* test/.rs test/.rs*
 	rm -f typescript test/typescript
@@ -317,7 +317,7 @@
 	rm -f $(INSTALLED_SHARED)
 	rmdir "$(target)/share/doc/reposurgeon"
 
-VERS=$(shell sh ./extractversion.sh <NEWS.adoc)
+VERS=$(shell sed -n <NEWS.adoc '/^[0-9]/s/:.*//p' | head -1)
 
 version:
 	@echo $(VERS)

=== test/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 REPOTOOL := repotool
 REPOMAPPER := repomapper
 
-# Setting this to 1 suppresses detail sections in most TAP reportts.
+# Setting this to 1 suppresses detail sections in most TAP reports.
 QUIET=0
 
 # The TAP filter. Only affects presentation of the test suite messages
@@ -29,7 +29,7 @@
 BUILDOPT="set serial"
 
 # See https://stackoverflow.com/questions/6481005/how-to-obtain-the-number-of-cpus-cores-in-linux-from-the-command-line
-CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)
+#CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)
 
 # Fall back to safety if our declared TAP consumer does not exist.
 # This is helpful in the CI environment, where it wiuld be better for
@@ -47,7 +47,8 @@
 # to hand a real status back. This is important for CI/CD.  
 FAILLOG=/tmp/reposurgeon-make.log
 
-# parallel-tap must not be run in parallel.
+# The default, run all tests.
+# parallel-tap must not itself be run in parallel.
 check:
 	@$(MAKE) -j1 --no-print-directory parallel-tap
 
@@ -63,6 +64,8 @@
 	sh $< -d >$@
 .svn.see:
 	@repocutter -q see <$< >$@
+.sh.fi:
+	sh $< >$@
 
 clean:
 	@rm -fr .rs* test=repo test-checkout test-repo* test-checkout* git-repo left-repo right-repo *~
@@ -100,6 +103,7 @@
 GENERATEDSVN=multigen.svn ignore.svn global-ignores.svn ignore-copy.svn global-ignores-copy.svn tagdoublet.svn \
 	mixedbranchlift.svn tagwithcommits.svn branchtagdoublet.svn multiprojectmerge.svn branchrenametipdelete.svn \
 	branchcreateempty.svn
+GENERATEDGIT=bubblegen.fi
 ignore.svn: ignoregen.sh
 	sh $< ignore >$@
 global-ignores.svn: ignoregen.sh
@@ -112,10 +116,10 @@
 # General regression testing of commands and output; look at the *.tst and
 # corresponding *.chk files to see which tests this runs.
 COMMAND_LOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
-COMMAND_TARGETS=$(COMMAND_LOADS:%=command-regress-%)
-$(COMMAND_TARGETS): command-regress-%: %.tst
+COMMAND_TARGETS=$(COMMAND_LOADS:%=command-check-%)
+$(COMMAND_TARGETS): command-check-%: %.tst
 	@singletest -a testing123 $< || echo "$@" >>$(FAILLOG);
-command-buildregress: $(GENERATEDSVN)
+command-buildcheck: $(GENERATEDSVN) $(GENERATEDGIT)
 	@for file in $(COMMAND_LOADS); do \
 	    echo "Remaking $${file}.chk"; \
 	    $(REPOSURGEON) $(BUILDOPT) "$(TESTOPT)" "script $${file}.tst testing123" >$${file}.chk \
@@ -125,7 +129,7 @@
 # Regression-yest loading from Subversion
 SVN_AND_TST_FILES := $(sort $(wildcard *.svn *.tst))
 SVNLOAD_LOADS := $(shell echo $(SVN_AND_TST_FILES) | sed 's/\([^ ]*\)\.svn \1.tst//g; s/[^ ]*\.tst//g; s/\.svn//g')
-svnload-buildregress:
+svnload-buildcheck:
 	@for test in $(SVNLOAD_LOADS); do \
 	    if [ -f $${test}.tst ] ; \
 	    then \
@@ -135,15 +139,15 @@
 		echo "Remaking $${test}.chk"; \
 		rm -f $${test}.chk && $(MAKE) --quiet $${test}.chk || exit 1; \
 	done
-SVNLOAD_TARGETS=$(SVNLOAD_LOADS:%=svnload-regress-%)
-$(SVNLOAD_TARGETS): svnload-regress-%: %.svn
+SVNLOAD_TARGETS=$(SVNLOAD_LOADS:%=svnload-check-%)
+$(SVNLOAD_TARGETS): svnload-check-%: %.svn
 	@(test=$(<:.svn=); legend=$$(sed -n '/^ ## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
 	$(REPOSURGEON) "$(TESTOPT)" "$(TESTOPT)" "read <$${test}.svn" "prefer git" "write -"  >/tmp/stream$$$$ 2>&1; \
 	tapdiffer "$<: $${legend}" $${test}.chk </tmp/stream$$$$ ) || echo "$@" >>$(FAILLOG);
 
 # Regression-testing of repocutter
 REPOCUTTER_LOADS := $(shell ls -1 repocutter*.sh | sed '/.sh$$/s///')
-repocutter-buildregress:
+repocutter-buildcheck:
 	@for file in $(REPOCUTTER_LOADS); do \
 	    echo "Remaking $${file}.chk"; \
 	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
@@ -156,7 +160,7 @@
 # Regression-testing of repomapper; look at the *.sh and
 # corresponding *.chk files to see which tests this runs.
 REPOMAPPER_LOADS := $(shell ls -1 repomapper*.sh | sed '/.sh/s///')
-repomapper-buildregress:
+repomapper-buildcheck:
 	@for file in $(REPOMAPPER_LOADS); do \
 	    echo "Remaking $${file}.chk"; \
 	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
@@ -168,7 +172,7 @@
 
 # Test legacy-map generation
 LEGACY_LOADS=nut mergeinfo-with-split
-legacy-buildregress:
+legacy-buildcheck:
 	@for test in $(LEGACY_LOADS); \
 	do \
 	    echo "Remaking $${test}.map"; \
@@ -190,7 +194,7 @@
 # These tests are actually here to check Subversion's behavior, in case something
 # poorly documented changes.
 SVNCHECK_LOADS := $(shell ls -1 svncheck*.sh | sed '/.sh/s///')
-svncheck-buildregress:
+svncheck-buildcheck:
 	@for file in $(SVNCHECK_LOADS); do \
 	    echo "Remaking $${file}.chk"; \
 	    $(SHELL) $${file}.sh -d | $(REPOSURGEON) "$(TESTOPT)" "set testmode" 'read -' 'prefer git' 'write -' >$${file}.chk || exit 1; \
@@ -215,8 +219,8 @@
 
 # Test Subversion conversion correctness
 LIFTCHECK_LOADS = $(wildcard *.svn)
-LIFTCHECK_TARGETS = $(LIFTCHECK_LOADS:%=liftcheck-regress-full-%)
-$(LIFTCHECK_TARGETS): liftcheck-regress-full-%: %
+LIFTCHECK_TARGETS = $(LIFTCHECK_LOADS:%=liftcheck-check-full-%)
+$(LIFTCHECK_TARGETS): liftcheck-check-full-%: %
 	@liftcheck -q -r all $< || echo "$@" >>$(FAILLOG);
 
 endif # if svn
@@ -245,7 +249,7 @@
 	@(./hg-to-fi <$< | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon/d' \
 	| tapdiffer "$<: hg extractor" $<) || echo "$@" >>$(FAILLOG);
 HGSCRIPTS = $(subst -test,,$(subst hg-,,$(wildcard hg-*-test)))
-hg-buildregress:
+hg-buildcheck:
 	@for item in $(HGSCRIPTS); do \
 	    echo "Remaking $${item}.fi"; \
 	    ./hg-$${item}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${item}.fi \
@@ -262,13 +266,41 @@
 
 endif # if git
 
+# BEGINS: Tests requiring bzr
+
+ifneq ($(call AVAILABLE bzr),)
+
+BZR_TARGETS=bzr-test-check
+bzr-test-check:
+	@(./bzrtest.sh bzr | tapdiffer "bzr export test" bzrtest.chk) || echo "$@" >>$(FAILLOG)
+bzr-buildcheck:
+	@./bzrtest.sh bzr >bzrtest.chk
+
+endif # if bzr
+
+# ENDS: Tests requiring bzr
+
+# BEGINS: Tests requiring brz
+
+ifneq ($(call AVAILABLE brz),)
+
+BRZ_TARGETS=brz-test-check
+brz-test-check:
+	@(./bzrtest.sh brz | tapdiffer "brz export test" brztest.chk) || echo "$@" >>$(FAILLOG)
+brz-buildcheck:
+	@./bzrtest.sh brz >brztest.chk
+
+endif # if brz
+
+# ENDS: Tests requiring brz
+
 # Test past this point may depend on any VCS and are expected
 # to die cleanly wuth a TAP complaint if they can't find what they need.
 
 # Regression-testing of repotool; look at the *.sh and
 # corresponding *.chk files to see which tests this runs.
 REPOTOOL_LOADS := $(shell ls -1 repotool*.sh | sed '/.sh/s///')
-repotool-buildregress:
+repotool-buildcheck:
 	@for file in $(REPOTOOL_LOADS); do \
 	    echo "Remaking $${file}.chk"; \
 	    $(SHELL) $${file}.sh --rebuild || exit 1; \
@@ -282,17 +314,3 @@
 SPORADIC_LOADS := hashcheck workflow-cvs-git workflow-svn-git incrementalcheck svndircopyprop
 SPORADIC_TARGETS = $(SPORADIC_LOADS:%=sporadic-test-%)
 $(SPORADIC_TARGETS): sporadic-test-%:
-	@$(SHELL) $*.sh || echo "$@" >>$(FAILLOG);
-
-# All test targets. Putting expensive targets early in this list might
-# shave a little off total time. The Subversion tools are much the slowest
-# so those tests start first.
-TEST_TARGETS = $(LIFTCHECK_TARGETS) $(SVNCHECK_TARGETS) \
-		$(GIT_EXTRACTOR_TARGETS) $(HGSTREAMS_EXTRACTOR_TARGETS) $(HG_EXTRACTOR_TARGETS) \
-		$(ROUNDTRIP_TARGETS) $(ROUNDTRIP_COMPRESS_TARGETS) $(MESSAGEBOX_TARGETS) \
-		$(COMMAND_TARGETS) $(SVNLOAD_TARGETS) $(LEGACY_TARGETS) \
-		$(REPOMAPPER_TARGETS) $(REPOTOOL_TARGETS) $(REPOCUTTER_TARGETS) \
-		$(SPORADIC_TARGETS)
-
-# Here's how we actually run the tests:
-

=== debian/changelog ===
reposurgeon (4.38-3) unstable; urgency=medium

  * Team upload.
  * Fix clean target. Closes: #1049272.
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * d/control: Drop "Priority: optional" (default).
  * d/control: Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Wed, 29 Oct 2025 10:30:00 +0100

reposurgeon (4.38-2) unstable; urgency=medium

  * Team upload.
  [ Aurelien Jarno ]
  * Build-Depends and Depends on tzdata-legacy to support obsolete
    System V names. Closes: #1085594.

 -- Santiago Vila <sanvila@debian.org>  Tue, 05 Nov 2024 12:10:00 +0100

reposurgeon (4.38-1) unstable; urgency=medium

  * New upstream version 4.38

 -- Anthony Fok <foka@debian.org>  Fri, 23 Feb 2024 18:06:39 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: reposurgeon
 Section: vcs
-Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Anthony Fok <foka@debian.org>
-Rules-Requires-Root: no
 Build-Depends: asciidoctor,
                cvs,
                debhelper-compat (= 13),
@@ -17,13 +15,14 @@
                golang-github-kballard-go-shellquote-dev (>= 0.0~git20180428.95032a8),
                golang-github-pkg-term-dev (>= 1.1.0),
                golang-github-xo-terminfo-dev (>= 0.0~git20210125.ca9a967),
-               golang-golang-x-crypto-dev,
-               golang-golang-x-text-dev,
+               golang-golang-x-term-dev (>= 0.0~git20210927.03fcf44),
+               golang-golang-x-text-dev (>= 0.3.7),
                mercurial,
                subversion,
-               time
+               time,
+               tzdata-legacy
 Testsuite: autopkgtest-pkg-go
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/reposurgeon
 Vcs-Git: https://salsa.debian.org/go-team/packages/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
@@ -32,6 +31,7 @@
 Package: reposurgeon
 Architecture: any
 Depends: tzdata,
+         tzdata-legacy,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: cvs,

=== debian/watch ===
# HTTP site (basic)
version=4
http://www.catb.org/~esr/reposurgeon/ \
    reposurgeon-(\d[\d.]*)\.tar\.(?:gz|bz2|xz) debian

# direct access to the git repository (tags)
#version=4
#opts="mode=git, gitmode=full, pgpmode=none" \
#    https://gitlab.com/esr/reposurgeon.git \
#    refs/tags/([\d\.]+) debian

# direct access to the git repository (HEAD)
#version=4
#opts="mode=git, pgpmode=none, pretty=4.4+git%cd.%h" \
#    https://gitlab.com/esr/reposurgeon.git \
#    HEAD debian
